import { CodeFix } from '../codeFixes';
/**

# description

declares undeclared variables or functions

# example

a=1 // before
const a = 1 // after

const result = nonDeclared(1,2,{a: 'g}) // before
// after:
function nonDeclared(arg1: number, arg2: number, arg3: {a: string}) {
  throw new Error('Not Implemented');
}
const result = nonDeclared(1,2,{a: 'g})

# attacks

"code": "2304", Cannot find name 'b'.",

# TODO

 * issue : this `visitClass(c, buffer)` is transformed into this:
  ```function visitClass(arg0: import("/home/sg/git/node-lucene/java2js/node_modules/javap/dist/types-ast").ClassDeclaration, arg1: string[]) {
    throw new Error('Not Implemented');
  }
  visitClass(c, buffer)```
  two issues there - the import and the args - use c and buffer instead of arg0 and arg1

  
 * if (existingProp && hasWrongSignature(existingProp, method)) -- is doing strange things on suggestion at hasWrongSignature

 * test with jsdoc or a trailing comment

 * Not offering for nonDeclared: ```afterEach(()=>{
    nonDeclared(config)
  })```

 * non declared methods and properties ?

*/
export declare const codeFixCreateVariable: CodeFix;
