import { CodeFix } from '../codeFixes';
/**

# Description:

When implementation miss to implement a member or is doing it incorrectly, select member name and accept suggestion "implement interface"

# Diagnostic error attacked:

"code": "2416","message": "Property 'method1' in type 'SomeImplementation' is not assignable to the same property in base type 'SomeInterface'.\n  Type '(param: number) => number[]' is not assignable to type '(param: string) => number[]'.\n    Types of parameters 'param' and 'param' are incompatible.\n      Type 'string' is not assignable to type 'number'.",

# How to reproduce:
```
interface SomeInterface {
  prop1: { s: string, n: Date }[]
}
class Class2 implements SomeInterface {
  prop1: boolean[]        <----- here select prop1 and implement interface it will fix prop1 signature
}
```

# TODO

 * TODO: work for constructors and setter/getter members
 * TODO: review
 *
 * TODO: this is failing:
class Unit {
  energy: number
}
const unit: Unit = {
  energy: 123, color: 'red'
}

 *  we choose any member signature - we should choose the most similar one
 
 * config:
```
config: {
    // recursive tre will generate the whole sub literals..
    recursive: false,
    // add missing properties declared to interface so there are no errors in strict mode
    addMissingPropertiesToInterface: false
  },
```
*/
export declare const implementInterfaceMember: CodeFix;
