"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_simple_ast_1 = require("ts-simple-ast");
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
/**
# description

function declarations without names when they are not called is an error - suggest putting a name

# attacks

"code": "1003",	"message": "Identifier expected."

# Example:
```
function(){}
```

# TODO

 * check if new variable doesn't already exists

 * config

*/
exports.nameFunction = {
    name: 'nameFunction',
    config: {
        // TODO: name to put to the unnamed function
        newName: 'unnamedFunction'
    },
    predicate: (arg) => {
        const fn = typescript_ast_util_1.findAscendant(arg.containingTargetLight, ts.isFunctionDeclaration, true);
        if (!fn || !arg.diagnostics.find(d => d.code === 1003 && d.start >= fn.getStart(arg.sourceFile) && d.start + d.length <= fn.getEnd())) {
            arg.log('predicate false because cannotfindAscendant(arg.containingTargetLight, ts.isFunctionDeclaration) or no diagnostic error 1003 code found in range');
            return false;
        }
        return true;
    },
    description: (arg) => `Name function`,
    apply: (arg) => {
        const f = ts_simple_ast_1.TypeGuards.isFunctionDeclaration(arg.simpleNode) ? arg.simpleNode : arg.simpleNode.getFirstAncestorByKind(ts.SyntaxKind.FunctionDeclaration);
        if (!f || f.getName()) {
            arg.log(`apply cannot exec because ${f.getKindName()} is not FunctionDeclaration or has name`);
            return;
        }
        else {
            const start = f.getNameNode().getStart();
            // TODO: check if new name doesn't already exists
            f.getSourceFile().insertText(f.getNameNode().getStart(), ' unnamedFunction');
        }
    }
};
//# sourceMappingURL=nameFunction.js.map