"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_simple_ast_1 = require("ts-simple-ast");
const ts = __importStar(require("typescript"));
const util_1 = require("../util");
/**

# Description

change string quote character - allowing to change a isNoSubstitutionTemplateLiteral to a regular string.

Note : for going back and forward from template strings use the fix gemplate2literal - this one is only for simple string literals
 
# Example

# TODO

*/
class StringChangeQuoteChar {
    constructor() {
        this.name = 'stringChangeQuoteChar';
        this.config = {};
    }
    predicate(arg) {
        this.newQuotes = undefined;
        if (ts.isStringLiteral(arg.containingTargetLight)) {
            this.newQuotes = arg.containingTargetLight.getText().startsWith('\'') ? '"' : '\'';
        }
        else if (ts.isNoSubstitutionTemplateLiteral(arg.containingTargetLight)) {
            this.newQuotes = '"';
        }
        return !!this.newQuotes;
    }
    description(arg) {
        return `Change string quotes to ${this.newQuotes}`;
    }
    apply(arg) {
        const node = arg.simpleNode;
        if (this.newQuotes && (ts_simple_ast_1.TypeGuards.isStringLiteral(node) || ts_simple_ast_1.TypeGuards.isNoSubstitutionTemplateLiteral(node))) {
            // changeQuoteChar(node, this.newQuotes)
            const code = util_1.quote(node.getLiteralText(), this.newQuotes);
            return util_1.buildRefactorEditInfo(arg.sourceFile, code, node.getStart(), node.getWidth());
            // return
        }
    }
}
exports.StringChangeQuoteChar = StringChangeQuoteChar;
exports.stringChangeQuoteChar = new StringChangeQuoteChar();
//# sourceMappingURL=stringChangeQuoteChar.js.map