import { CodeFix, CodeFixOptions } from "../codeFixes";
/**

# Description

utilities related to strings:

 * change string quote character
 * go from normal string concatenation to template strings and viceversa
 *
 
# Example

# TODO

 * TODO: still missing the part that transform from string concat to string templates
 * TaggedTemplateExpression getExpression and remove tag - has some utilitiesfor working with rxjs - perhaps we want to include those here?
 * TODO: recurse on expressions that have templateExpressions descendants
 * allow me to convert string concat (a binaryoperationexpression into a single templateExpression
 * console.log('a'+b+'c') -  change to template or viceversa works funny....
*/
export declare class Template2Literal implements CodeFix {
    name: string;
    config: {
        recurseOnTemplateExpressions: boolean;
        wrapStringConcatenationWithParenthesis: boolean;
    };
    action: 'changeToLiteral' | 'changeToTemplate' | 'changeConcatenationToTemplate' | undefined;
    predicate(arg: CodeFixOptions): boolean;
    description(arg: CodeFixOptions): string;
    apply(arg: CodeFixOptions): void;
    private templateExprToStringConcat;
    private exprBuffer;
    private stringConcatExpr2TemplateRecursively;
    private stringConcatExpr2Template;
    private expression2String;
    private isString;
    private isString2;
}
export declare const template2Literal: Template2Literal;
