import * as ts from 'typescript';
import { CodeFix } from '../codeFixes';
/**
 
# Description

see https://github.com/Microsoft/TypeScript/issues/23552

# Attacks

This refactor doesn't attack any diagnostic error

# Example

```
function foo (a: number, b: string[], c: (n:number)=>boolean[], d?: boolean){}
```

select a fragment of the parameter list will suggest "declare interface from named parameters" and if applied will change the code to :

```
interface FooOptions{
  a: number
  b: string[]
  c?: boolean
}
function foo({a,b,c}: FooOptions){}
```

# TODO

*/
export declare const toNamedParameters: CodeFix;
export declare function buildTextChange(newText: string, start: number, length?: number): ts.TextChange;
