"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_simple_ast_1 = require("ts-simple-ast");
const ts = __importStar(require("typescript"));
const typescript_ast_util_1 = require("typescript-ast-util");
/**
 
# Description

This is the opposite as fixImplementation* - when the implementation implements an interface or class incorrectly it ill fix the interface/class instead of the implementation by adding/removing

WARNING: this is probably very dangerous operation but could be useful on initial quick type modeling from data

# Example:
```
let a = 1
//....
let a = 's'
// ....
function a(){}
class a{}
```
# Attacks:

"code": "2451", "message": "Cannot redeclare block-scoped variable 'a'.",

# TODO

 * config
 * check if new variable doesn't already exists

*/
exports.renameVariable = {
    name: 'variableRename',
    config: {
    //TODO: rename policy - is a postfix counter, postfix prefix, static postfix or prefix or what 
    },
    predicate: (options) => {
        if (options.containingTargetLight.kind === ts.SyntaxKind.Identifier &&
            options.diagnostics.find(d => d.code === 2451 && d.start === options.containingTargetLight.getStart())) {
            return true;
        }
        else {
            options.log('predicate false because Identifier != ' + typescript_ast_util_1.getKindName(options.containingTarget.kind));
            return false;
        }
    },
    description: (options) => `Rename variable "${options.containingTarget.getText()}"`,
    apply: (options) => {
        const id = options.simpleNode;
        if (!ts_simple_ast_1.TypeGuards.isIdentifier(id)) {
            options.log('apply false because  false because Identifier != ' + typescript_ast_util_1.getKindName(options.containingTarget.kind));
            return;
        }
        // TODO: check if new variable doesn't already exists
        id.rename(id.getText() + '2');
    }
};
//# sourceMappingURL=variableRename.js.map