"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const addReturnStatement_1 = require("./code-fix/addReturnStatement");
const arrowFunctionTransformations_1 = require("./code-fix/arrowFunctionTransformations");
const const2let_1 = require("./code-fix/const2let");
const declareClass_1 = require("./code-fix/declareClass");
const declareConstructor_1 = require("./code-fix/declareConstructor");
const declareMember_1 = require("./code-fix/declareMember");
const declareReturnType_1 = require("./code-fix/declareReturnType");
const declareVariable_1 = require("./code-fix/declareVariable");
const extractInterface_1 = require("./code-fix/extractInterface");
const implementInterfaceMember_1 = require("./code-fix/implementInterfaceMember");
const implementInterfaceObjectLiteral_1 = require("./code-fix/implementInterfaceObjectLiteral");
const memberChangeScope_1 = require("./code-fix/memberChangeScope");
const methodDelegate_1 = require("./code-fix/methodDelegate");
const nameFunction_1 = require("./code-fix/nameFunction");
const removeEmptyLines_1 = require("./code-fix/removeEmptyLines");
const splitVariableDeclarationList_1 = require("./code-fix/splitVariableDeclarationList");
const stringChangeQuoteChar_1 = require("./code-fix/stringChangeQuoteChar");
const template2Literal_1 = require("./code-fix/template2Literal");
const toNamedParams_1 = require("./code-fix/toNamedParams");
const variableRename_1 = require("./code-fix/variableRename");
const organizeImportsAndFormat_1 = require("./code-fix/organizeImportsAndFormat");
const removeComments_1 = require("./code-fix/removeComments");
exports.codeFixes = [declareConstructor_1.codeFixCreateConstructor, declareVariable_1.codeFixCreateVariable, declareClass_1.declareClass, const2let_1.const2let, nameFunction_1.nameFunction, implementInterfaceObjectLiteral_1.implementInterfaceObjectLiteral, declareReturnType_1.declareReturnType, declareMember_1.declareMember, addReturnStatement_1.addReturnStatement, implementInterfaceMember_1.implementInterfaceMember, variableRename_1.renameVariable, splitVariableDeclarationList_1.splitVariableDeclarationList, toNamedParams_1.toNamedParameters, memberChangeScope_1.memberChangeScope, removeEmptyLines_1.removeEmptyLines, arrowFunctionTransformations_1.arrowFunctionBodyTransformations, extractInterface_1.extractInterface, methodDelegate_1.methodDelegate, template2Literal_1.template2Literal, stringChangeQuoteChar_1.stringChangeQuoteChar, organizeImportsAndFormat_1.organizeImportsAndFormat, removeComments_1.removeComments];
//# sourceMappingURL=codeFixes.js.map