import { ClassDeclaration, ExpressionWithTypeArguments, FunctionLikeDeclaration, InterfaceDeclaration, MethodSignature, Node, ParameterDeclaration, ParameterDeclarationStructure, Type, StringLiteral, NoSubstitutionTemplateLiteral, MethodDeclaration } from "ts-simple-ast";
import * as ts from 'typescript';
export declare const buildParameterStructure: (p: ParameterDeclaration) => ParameterDeclarationStructure;
/** fix given function-like declaration parameters and type to implement given signature */
export declare function fixSignature(decl: FunctionLikeDeclaration, signature: MethodSignature | MethodDeclaration): void;
/** dirty way of checking if two types are compatible */
export declare function areTypesEqual(t1: Type, t2: Type): boolean;
/**
 * returns all implements clauses of this class and its super classes both things recursively
 */
export declare const getImplementsAll: (cl: ClassDeclaration) => ExpressionWithTypeArguments[];
export declare const getExtendsRecursively: (decl: ClassDeclaration | InterfaceDeclaration) => ExpressionWithTypeArguments[];
export declare const findInterfacesWithPropertyNamed: (decl: ClassDeclaration, memberName: string) => InterfaceDeclaration[];
/**
 * returns a default representation of given type, for example `''` for `string`, `[]` for `Array`, etc.
 * TODO: this should support recursion in case it references another interface - we can recreate the whole thing recursively...
 */
export declare function getDefaultValueForType(t: Type): string;
export declare function getName(node: Node, defaultName?: string): string;
export declare function quote(s: any, q: any): any;
export declare function changeQuoteChar(node: StringLiteral | NoSubstitutionTemplateLiteral, newQuoteChar: string): void;
export declare function buildRefactorEditInfo(sourceFile: ts.SourceFile, newText: string, start?: number, length?: number): ts.RefactorEditInfo;
